""" IQ logging module """

#!/usr/bin/env python
# Copyright (c) 2011-2013 by IQ2 Development GmbH, Neckartenzlingen 
# All rights reserved

from datetime import datetime

# log types
NO_LOG = None
VERBOSE_LOG = "VERBOSE"
INFO_LOG = "INFO"
ERROR_LOG = "ERROR"


def log(type, package, message, time=None):
    """ Log function

    If time is not given, time now is used

    >>> log(NO_LOG, "iqlog", "Hello")

    >>> log(VERBOSE_LOG, "iqlog", "Hello", "2013-09-18 12:19:02.417000")
    2013-09-18 12:19:02.417000 VERBOSE iqlog:
    Hello

    """
    time = ""
    if time is None:
        time = datetime.now().strftime("%Y-%m-%d %H:%M:%S.%f") + ' '
    if type:
        print (time + type, package + ":")

    print (time + message)